
/*
 *  hashstr  -  hash a string both as an inline routine and as a program
 *
 *  $Id: hashstr.c,v 1.1 2000/08/27 03:59:56 bruce Exp $
 */
#include <stdio.h>
#include <string.h>
#include <sys/param.h>

inline unsigned long
hashstr( const char* pz )
{
    int len = strlen( pz );
    register unsigned long  res = 0UL;
    register unsigned long* pd  = (unsigned long*)pz;
    register unsigned long  low_bit;

    while (len >= sizeof( res )) {
        low_bit =
            (res & (1 << ((NBBY * sizeof( res ))-1))) ? 1UL : 0UL;
        res <<= 1UL;
        res |= low_bit;
        res ^= *(pd++);
        len -= sizeof( res );
    }

    if (len > 0) {
        unsigned long bits = 0UL;
        pz = (char*)pd;
        while (--len >= 0)
            ((char*)&bits)[len] = *(pz++);
        low_bit =
            (res & (1 << ((NBBY * sizeof( res ))-1))) ? 1UL : 0UL;
        res <<= 1UL;
        res |= low_bit;
        res ^= bits;
    }

    return res;
}
#ifndef NO_MAIN

int
main( int     argc,
      char**  argv )
{
    char z[ 10 ];
    sprintf( z, "0x%%0%dlX\n", NBBY * sizeof( long ) / 4 );

    if (argc < 2)
        printf( z, 0UL );
    else
        printf( z, hashstr( argv[1] ));

    return 0;
}
#endif
