[= AutoGen5 Template -*- Mode: C -*-

x

#  $Id: regen.tpl,v 1.6 2000/09/04 19:13:59 bruce Exp $

=]
/*
[=( dne " *  " )=]
 *
 *  This file is used to compute three lists:
 *
 *  1.  The list of all files derived from the list of files being
 *      committed.
 *
 *  2.  The list of all files used to create these files.  This is
 *      a superset of the list of files being checked in, tho it may
 *      also be the identical set.
 *
 *  3.  The mapping from the derived file index to a build rule.
 *      Where there is more than one file produced, only the first
 *      derived file will have the associated rule.  The rule must
 *      build all the files.
 *
 *  The list of file names we will worry about:
 */
[=
(out-push-new ".regen.names")
(join "\n" (stack "generate.target") (stack "generate.dep")) =][=

(out-pop)
(shell "
   sort -u .regen.names |
   while read f
   do
      g=`./hashstr $f`
      echo \"tSCC z_${g}[] = \\\"$f\\\";\"
   done")

=]

/*
 *  For every predecessor file, emit the list of derived files
 */
[=

(out-push-new ".regen.deps")
(join "\n" (stack "generate.dep")) =][=

(out-pop)
(shell
  "sort -u -o .regen.X .regen.deps
   set -- `cat .regen.X`")
(out-push-new ".regen.deps")

=][=

WHILE `if test $# -gt 0 ; then f=${1} ; echo "${f}" ; shift ; fi`


=]tSCC* apz_[=`./hashstr "$f"` =]_targets[] = {[=

  #  FOR every generate definition that has a dep that matches,
  #    emit all of its targets
  =][=

  FOR generate =][=
    IF (match-value? == "dep" (shell "echo $f")) =][=
      FOR target =] z_[= % target `./hashstr %s` =],[=
      ENDFOR =][=
    ENDIF =][=
  ENDFOR =] NULL};
[=
ENDWHILE =][=

(out-pop)
(shell "sort .regen.deps ; set -- `cat .regen.X`")

=]

#define DEP_TO_TARGETS_CT [=`wc -l < .regen.X`=]
t_dep_desc dep_to_targets[ DEP_TO_TARGETS_CT ] = {
[= `for f in \`cat .regen.X\`
    do ./hashstr $f ; done | \
      sort | \
      while read g
      do echo "    { ${g}UL, z_${g}, apz_${g}_targets },"
      done | \
      sed '$s/,$//' `=]
};


/*
 *  For every derived file, emit the list of predecessor files
 */[=


FOR generate =][=
  FOR target =]
tSCC* apz_[=% target `./hashstr %s`=]_deps[] = {[=
    FOR dep =] z_[=% dep `./hashstr %s`=],[=
    ENDFOR =] NULL };[=
  ENDFOR =][=
ENDFOR

=]
[=

(out-push-new ".regen.tags") =][=

FOR generate =][=
  FOR target =]
    [= % target `g=\`./hashstr %s\`
         echo "{ ${g}UL, z_${g}, apz_${g}_deps},"` =][=
  ENDFOR =][=
ENDFOR   =][=

(out-pop) =]
#define TARGET_TO_DEPS_CT [=`wc -l < .regen.tags`=]
t_dep_desc target_to_deps[ TARGET_TO_DEPS_CT ] = {[=

 `sort .regen.tags | sed '$s/,$//'
  rm -f .regen.*`

=]
};

/*
 *  Rules for building the targets:
 */[=
(define rule-name "")
(define rule-size  0)
(define max-rule   0) =][=

FOR generate "\n" =][=

(set! rule-name (sprintf "z_gen_rule%d" (for-index)))
(set! rule-size (len "rule"))
(if (> rule-size max-rule)
    (set! max-rule rule-size))

=]
tSCC [=(. rule-name)=][] =
       [=(c-string (get "rule"))=];[=

  FOR target         =]
#define z_[= % target `./hashstr %s` =]_rule [=
    IF (first-for?)  =][=(. rule-name)=][=
    ELSE             =]NULL[=
    ENDIF            =][=
  ENDFOR             =][=
ENDFOR =]

tCC*  target_rules[ TARGET_TO_DEPS_CT ] = {
[= (out-push-new ".regen.rules") =][=
FOR generate =][=
  FOR target
    =]z_[= % target `./hashstr %s` =]_rule
[=ENDFOR     =][=
ENDFOR =][=
(out-pop)
(shell "sort .regen.rules | columns --sep=, -I4 ; rm -f .regen.rules") =]
};

#define MAX_FORMAT_SIZE [=(+ max-rule 1024)=]
